package com.sun.org.apache.xalan.internal.xsltc.compiler;

import java.util.List;
import java.util.ArrayList;
import com.sun.java_cup.internal.runtime.Symbol;
import java.util.Stack;
import com.sun.java_cup.internal.runtime.lr_parser;

class parser_actions
{
    private final XPathParser parser;
    
    parser_actions(XPathParser parser) {
        this.parser = parser;
    }
    
    public final Symbol parser_do_action(int parser_act_num, lr_parser parser_parser, Stack<Symbol> parser_stack, int parser_top) throws Exception {
        switch (parser_act_num) {
            case 0: {
                SyntaxTreeNode start_val = (SyntaxTreeNode)((Symbol)parser_stack.get(parser_top - 1)).value;
                Symbol parser_result = new Symbol(0, ((Symbol)parser_stack.get(parser_top - 1)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, start_val);
                parser_parser.done_parsing();
                return parser_result;
            }
            case 1: {
                Pattern pattern = (Pattern)((Symbol)parser_stack.get(parser_top - 0)).value;
                Symbol parser_result = new Symbol(1, ((Symbol)parser_stack.get(parser_top - 1)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, pattern);
                return parser_result;
            }
            case 2: {
                Expression expr = (Expression)((Symbol)parser_stack.get(parser_top - 0)).value;
                Symbol parser_result = new Symbol(1, ((Symbol)parser_stack.get(parser_top - 1)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, expr);
                return parser_result;
            }
            case 3: {
                Pattern lpp = (Pattern)((Symbol)parser_stack.get(parser_top - 0)).value;
                Symbol parser_result = new Symbol(28, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, lpp);
                return parser_result;
            }
            case 4: {
                Pattern lpp = (Pattern)((Symbol)parser_stack.get(parser_top - 2)).value;
                Pattern p = (Pattern)((Symbol)parser_stack.get(parser_top - 0)).value;
                Pattern result = new AlternativePattern(lpp, p);
                Symbol parser_result = new Symbol(28, ((Symbol)parser_stack.get(parser_top - 2)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result);
                return parser_result;
            }
            case 5: {
                Pattern result2 = new AbsolutePathPattern(null);
                Symbol parser_result = new Symbol(29, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result2);
                return parser_result;
            }
            case 6: {
                RelativePathPattern rpp = (RelativePathPattern)((Symbol)parser_stack.get(parser_top - 0)).value;
                Pattern result3 = new AbsolutePathPattern(rpp);
                Symbol parser_result = new Symbol(29, ((Symbol)parser_stack.get(parser_top - 1)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result3);
                return parser_result;
            }
            case 7: {
                IdKeyPattern ikp = (IdKeyPattern)((Symbol)parser_stack.get(parser_top - 0)).value;
                Symbol parser_result = new Symbol(29, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, ikp);
                return parser_result;
            }
            case 8: {
                IdKeyPattern ikp = (IdKeyPattern)((Symbol)parser_stack.get(parser_top - 2)).value;
                RelativePathPattern rpp2 = (RelativePathPattern)((Symbol)parser_stack.get(parser_top - 0)).value;
                Pattern result = new ParentPattern(ikp, rpp2);
                Symbol parser_result = new Symbol(29, ((Symbol)parser_stack.get(parser_top - 2)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result);
                return parser_result;
            }
            case 9: {
                IdKeyPattern ikp = (IdKeyPattern)((Symbol)parser_stack.get(parser_top - 2)).value;
                RelativePathPattern rpp2 = (RelativePathPattern)((Symbol)parser_stack.get(parser_top - 0)).value;
                Pattern result = new AncestorPattern(ikp, rpp2);
                Symbol parser_result = new Symbol(29, ((Symbol)parser_stack.get(parser_top - 2)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result);
                return parser_result;
            }
            case 10: {
                RelativePathPattern rpp = (RelativePathPattern)((Symbol)parser_stack.get(parser_top - 0)).value;
                Pattern result3 = new AncestorPattern(rpp);
                Symbol parser_result = new Symbol(29, ((Symbol)parser_stack.get(parser_top - 1)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result3);
                return parser_result;
            }
            case 11: {
                RelativePathPattern rpp = (RelativePathPattern)((Symbol)parser_stack.get(parser_top - 0)).value;
                Symbol parser_result = new Symbol(29, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, rpp);
                return parser_result;
            }
            case 12: {
                String l = (String)((Symbol)parser_stack.get(parser_top - 1)).value;
                IdKeyPattern result4 = new IdPattern(l);
                this.parser.setHasIdCall(true);
                Symbol parser_result = new Symbol(27, ((Symbol)parser_stack.get(parser_top - 3)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result4);
                return parser_result;
            }
            case 13: {
                String l2 = (String)((Symbol)parser_stack.get(parser_top - 3)).value;
                String l3 = (String)((Symbol)parser_stack.get(parser_top - 1)).value;
                IdKeyPattern result5 = new KeyPattern(l2, l3);
                Symbol parser_result = new Symbol(27, ((Symbol)parser_stack.get(parser_top - 5)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result5);
                return parser_result;
            }
            case 14: {
                String l = (String)((Symbol)parser_stack.get(parser_top - 1)).value;
                StepPattern result6 = new ProcessingInstructionPattern(l);
                Symbol parser_result = new Symbol(30, ((Symbol)parser_stack.get(parser_top - 3)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result6);
                return parser_result;
            }
            case 15: {
                StepPattern sp = (StepPattern)((Symbol)parser_stack.get(parser_top - 0)).value;
                Symbol parser_result = new Symbol(31, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, sp);
                return parser_result;
            }
            case 16: {
                StepPattern sp = (StepPattern)((Symbol)parser_stack.get(parser_top - 2)).value;
                RelativePathPattern rpp2 = (RelativePathPattern)((Symbol)parser_stack.get(parser_top - 0)).value;
                RelativePathPattern result7 = new ParentPattern(sp, rpp2);
                Symbol parser_result = new Symbol(31, ((Symbol)parser_stack.get(parser_top - 2)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result7);
                return parser_result;
            }
            case 17: {
                StepPattern sp = (StepPattern)((Symbol)parser_stack.get(parser_top - 2)).value;
                RelativePathPattern rpp2 = (RelativePathPattern)((Symbol)parser_stack.get(parser_top - 0)).value;
                RelativePathPattern result7 = new AncestorPattern(sp, rpp2);
                Symbol parser_result = new Symbol(31, ((Symbol)parser_stack.get(parser_top - 2)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result7);
                return parser_result;
            }
            case 18: {
                Object nt = ((Symbol)parser_stack.get(parser_top - 0)).value;
                StepPattern result6 = this.parser.createStepPattern(3, nt, null);
                Symbol parser_result = new Symbol(32, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result6);
                return parser_result;
            }
            case 19: {
                Object nt = ((Symbol)parser_stack.get(parser_top - 1)).value;
                List<Predicate> pp = (ArrayList)((Symbol)parser_stack.get(parser_top - 0)).value;
                StepPattern result8 = this.parser.createStepPattern(3, nt, pp);
                Symbol parser_result = new Symbol(32, ((Symbol)parser_stack.get(parser_top - 1)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result8);
                return parser_result;
            }
            case 20: {
                StepPattern pip = (StepPattern)((Symbol)parser_stack.get(parser_top - 0)).value;
                Symbol parser_result = new Symbol(32, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, pip);
                return parser_result;
            }
            case 21: {
                StepPattern pip = (StepPattern)((Symbol)parser_stack.get(parser_top - 1)).value;
                List<Predicate> pp = (ArrayList)((Symbol)parser_stack.get(parser_top - 0)).value;
                StepPattern result8 = (StepPattern)pip.setPredicates(pp);
                Symbol parser_result = new Symbol(32, ((Symbol)parser_stack.get(parser_top - 1)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result8);
                return parser_result;
            }
            case 22: {
                Integer axis = (Integer)((Symbol)parser_stack.get(parser_top - 1)).value;
                Object nt2 = ((Symbol)parser_stack.get(parser_top - 0)).value;
                StepPattern result8 = this.parser.createStepPattern((int)axis, nt2, null);
                Symbol parser_result = new Symbol(32, ((Symbol)parser_stack.get(parser_top - 1)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result8);
                return parser_result;
            }
            case 23: {
                Integer axis = (Integer)((Symbol)parser_stack.get(parser_top - 2)).value;
                Object nt2 = ((Symbol)parser_stack.get(parser_top - 1)).value;
                List<Predicate> pp2 = (ArrayList)((Symbol)parser_stack.get(parser_top - 0)).value;
                StepPattern result9 = this.parser.createStepPattern((int)axis, nt2, pp2);
                Symbol parser_result = new Symbol(32, ((Symbol)parser_stack.get(parser_top - 2)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result9);
                return parser_result;
            }
            case 24: {
                StepPattern result6;
                StepPattern pip = result6 = (StepPattern)((Symbol)parser_stack.get(parser_top - 0)).value;
                Symbol parser_result = new Symbol(32, ((Symbol)parser_stack.get(parser_top - 1)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result6);
                return parser_result;
            }
            case 25: {
                StepPattern pip = (StepPattern)((Symbol)parser_stack.get(parser_top - 1)).value;
                List<Predicate> pp = (ArrayList)((Symbol)parser_stack.get(parser_top - 0)).value;
                StepPattern result8 = (StepPattern)pip.setPredicates(pp);
                Symbol parser_result = new Symbol(32, ((Symbol)parser_stack.get(parser_top - 2)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result8);
                return parser_result;
            }
            case 26: {
                Object nt = ((Symbol)parser_stack.get(parser_top - 0)).value;
                Symbol parser_result = new Symbol(33, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, nt);
                return parser_result;
            }
            case 27: {
                Object result10 = Integer.valueOf(-1);
                Symbol parser_result = new Symbol(33, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result10);
                return parser_result;
            }
            case 28: {
                Object result10 = Integer.valueOf(3);
                Symbol parser_result = new Symbol(33, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result10);
                return parser_result;
            }
            case 29: {
                Object result10 = Integer.valueOf(8);
                Symbol parser_result = new Symbol(33, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result10);
                return parser_result;
            }
            case 30: {
                Object result10 = Integer.valueOf(7);
                Symbol parser_result = new Symbol(33, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result10);
                return parser_result;
            }
            case 31: {
                Object result10 = null;
                Symbol parser_result = new Symbol(34, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result10);
                return parser_result;
            }
            case 32: {
                QName qn = (QName)((Symbol)parser_stack.get(parser_top - 0)).value;
                Symbol parser_result = new Symbol(34, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, qn);
                return parser_result;
            }
            case 33: {
                Integer result11 = Integer.valueOf(2);
                Symbol parser_result = new Symbol(42, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result11);
                return parser_result;
            }
            case 34: {
                Integer result11 = Integer.valueOf(3);
                Symbol parser_result = new Symbol(42, ((Symbol)parser_stack.get(parser_top - 1)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result11);
                return parser_result;
            }
            case 35: {
                Integer result11 = Integer.valueOf(2);
                Symbol parser_result = new Symbol(42, ((Symbol)parser_stack.get(parser_top - 1)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result11);
                return parser_result;
            }
            case 36: {
                Expression p2 = (Expression)((Symbol)parser_stack.get(parser_top - 0)).value;
                List<Expression> temp = new ArrayList();
                temp.add(p2);
                Symbol parser_result = new Symbol(35, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, temp);
                return parser_result;
            }
            case 37: {
                Expression p2 = (Expression)((Symbol)parser_stack.get(parser_top - 1)).value;
                List<Expression> pp3 = (ArrayList)((Symbol)parser_stack.get(parser_top - 0)).value;
                pp3.add(0, p2);
                Symbol parser_result = new Symbol(35, ((Symbol)parser_stack.get(parser_top - 1)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, pp3);
                return parser_result;
            }
            case 38: {
                Expression e = (Expression)((Symbol)parser_stack.get(parser_top - 1)).value;
                Expression result12 = new Predicate(e);
                Symbol parser_result = new Symbol(5, ((Symbol)parser_stack.get(parser_top - 2)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result12);
                return parser_result;
            }
            case 39: {
                Expression ex = (Expression)((Symbol)parser_stack.get(parser_top - 0)).value;
                Symbol parser_result = new Symbol(2, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, ex);
                return parser_result;
            }
            case 40: {
                Expression ae = (Expression)((Symbol)parser_stack.get(parser_top - 0)).value;
                Symbol parser_result = new Symbol(8, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, ae);
                return parser_result;
            }
            case 41: {
                Expression oe = (Expression)((Symbol)parser_stack.get(parser_top - 2)).value;
                Expression ae2 = (Expression)((Symbol)parser_stack.get(parser_top - 0)).value;
                Expression result13 = new LogicalExpr(0, oe, ae2);
                Symbol parser_result = new Symbol(8, ((Symbol)parser_stack.get(parser_top - 2)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result13);
                return parser_result;
            }
            case 42: {
                Expression e = (Expression)((Symbol)parser_stack.get(parser_top - 0)).value;
                Symbol parser_result = new Symbol(9, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, e);
                return parser_result;
            }
            case 43: {
                Expression ae = (Expression)((Symbol)parser_stack.get(parser_top - 2)).value;
                Expression ee = (Expression)((Symbol)parser_stack.get(parser_top - 0)).value;
                Expression result13 = new LogicalExpr(1, ae, ee);
                Symbol parser_result = new Symbol(9, ((Symbol)parser_stack.get(parser_top - 2)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result13);
                return parser_result;
            }
            case 44: {
                Expression re = (Expression)((Symbol)parser_stack.get(parser_top - 0)).value;
                Symbol parser_result = new Symbol(10, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, re);
                return parser_result;
            }
            case 45: {
                Expression ee2 = (Expression)((Symbol)parser_stack.get(parser_top - 2)).value;
                Expression re2 = (Expression)((Symbol)parser_stack.get(parser_top - 0)).value;
                Expression result13 = new EqualityExpr(0, ee2, re2);
                Symbol parser_result = new Symbol(10, ((Symbol)parser_stack.get(parser_top - 2)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result13);
                return parser_result;
            }
            case 46: {
                Expression ee2 = (Expression)((Symbol)parser_stack.get(parser_top - 2)).value;
                Expression re2 = (Expression)((Symbol)parser_stack.get(parser_top - 0)).value;
                Expression result13 = new EqualityExpr(1, ee2, re2);
                Symbol parser_result = new Symbol(10, ((Symbol)parser_stack.get(parser_top - 2)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result13);
                return parser_result;
            }
            case 47: {
                Expression ae = (Expression)((Symbol)parser_stack.get(parser_top - 0)).value;
                Symbol parser_result = new Symbol(11, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, ae);
                return parser_result;
            }
            case 48: {
                Expression re = (Expression)((Symbol)parser_stack.get(parser_top - 2)).value;
                Expression ae2 = (Expression)((Symbol)parser_stack.get(parser_top - 0)).value;
                Expression result13 = new RelationalExpr(3, re, ae2);
                Symbol parser_result = new Symbol(11, ((Symbol)parser_stack.get(parser_top - 2)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result13);
                return parser_result;
            }
            case 49: {
                Expression re = (Expression)((Symbol)parser_stack.get(parser_top - 2)).value;
                Expression ae2 = (Expression)((Symbol)parser_stack.get(parser_top - 0)).value;
                Expression result13 = new RelationalExpr(2, re, ae2);
                Symbol parser_result = new Symbol(11, ((Symbol)parser_stack.get(parser_top - 2)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result13);
                return parser_result;
            }
            case 50: {
                Expression re = (Expression)((Symbol)parser_stack.get(parser_top - 2)).value;
                Expression ae2 = (Expression)((Symbol)parser_stack.get(parser_top - 0)).value;
                Expression result13 = new RelationalExpr(5, re, ae2);
                Symbol parser_result = new Symbol(11, ((Symbol)parser_stack.get(parser_top - 2)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result13);
                return parser_result;
            }
            case 51: {
                Expression re = (Expression)((Symbol)parser_stack.get(parser_top - 2)).value;
                Expression ae2 = (Expression)((Symbol)parser_stack.get(parser_top - 0)).value;
                Expression result13 = new RelationalExpr(4, re, ae2);
                Symbol parser_result = new Symbol(11, ((Symbol)parser_stack.get(parser_top - 2)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result13);
                return parser_result;
            }
            case 52: {
                Expression me = (Expression)((Symbol)parser_stack.get(parser_top - 0)).value;
                Symbol parser_result = new Symbol(12, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, me);
                return parser_result;
            }
            case 53: {
                Expression ae = (Expression)((Symbol)parser_stack.get(parser_top - 2)).value;
                Expression me2 = (Expression)((Symbol)parser_stack.get(parser_top - 0)).value;
                Expression result13 = new BinOpExpr(0, ae, me2);
                Symbol parser_result = new Symbol(12, ((Symbol)parser_stack.get(parser_top - 2)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result13);
                return parser_result;
            }
            case 54: {
                Expression ae = (Expression)((Symbol)parser_stack.get(parser_top - 2)).value;
                Expression me2 = (Expression)((Symbol)parser_stack.get(parser_top - 0)).value;
                Expression result13 = new BinOpExpr(1, ae, me2);
                Symbol parser_result = new Symbol(12, ((Symbol)parser_stack.get(parser_top - 2)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result13);
                return parser_result;
            }
            case 55: {
                Expression ue = (Expression)((Symbol)parser_stack.get(parser_top - 0)).value;
                Symbol parser_result = new Symbol(13, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, ue);
                return parser_result;
            }
            case 56: {
                Expression me = (Expression)((Symbol)parser_stack.get(parser_top - 2)).value;
                Expression ue2 = (Expression)((Symbol)parser_stack.get(parser_top - 0)).value;
                Expression result13 = new BinOpExpr(2, me, ue2);
                Symbol parser_result = new Symbol(13, ((Symbol)parser_stack.get(parser_top - 2)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result13);
                return parser_result;
            }
            case 57: {
                Expression me = (Expression)((Symbol)parser_stack.get(parser_top - 2)).value;
                Expression ue2 = (Expression)((Symbol)parser_stack.get(parser_top - 0)).value;
                Expression result13 = new BinOpExpr(3, me, ue2);
                Symbol parser_result = new Symbol(13, ((Symbol)parser_stack.get(parser_top - 2)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result13);
                return parser_result;
            }
            case 58: {
                Expression me = (Expression)((Symbol)parser_stack.get(parser_top - 2)).value;
                Expression ue2 = (Expression)((Symbol)parser_stack.get(parser_top - 0)).value;
                Expression result13 = new BinOpExpr(4, me, ue2);
                Symbol parser_result = new Symbol(13, ((Symbol)parser_stack.get(parser_top - 2)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result13);
                return parser_result;
            }
            case 59: {
                Expression ue = (Expression)((Symbol)parser_stack.get(parser_top - 0)).value;
                Symbol parser_result = new Symbol(14, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, ue);
                return parser_result;
            }
            case 60: {
                Expression ue = (Expression)((Symbol)parser_stack.get(parser_top - 0)).value;
                Expression result12 = new UnaryOpExpr(ue);
                Symbol parser_result = new Symbol(14, ((Symbol)parser_stack.get(parser_top - 1)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result12);
                return parser_result;
            }
            case 61: {
                Expression pe = (Expression)((Symbol)parser_stack.get(parser_top - 0)).value;
                Symbol parser_result = new Symbol(18, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, pe);
                return parser_result;
            }
            case 62: {
                Expression pe = (Expression)((Symbol)parser_stack.get(parser_top - 2)).value;
                Expression rest = (Expression)((Symbol)parser_stack.get(parser_top - 0)).value;
                Expression result13 = new UnionPathExpr(pe, rest);
                Symbol parser_result = new Symbol(18, ((Symbol)parser_stack.get(parser_top - 2)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result13);
                return parser_result;
            }
            case 63: {
                Expression lp = (Expression)((Symbol)parser_stack.get(parser_top - 0)).value;
                Symbol parser_result = new Symbol(19, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, lp);
                return parser_result;
            }
            case 64: {
                Expression fexp = (Expression)((Symbol)parser_stack.get(parser_top - 0)).value;
                Symbol parser_result = new Symbol(19, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, fexp);
                return parser_result;
            }
            case 65: {
                Expression fexp = (Expression)((Symbol)parser_stack.get(parser_top - 2)).value;
                Expression rlp = (Expression)((Symbol)parser_stack.get(parser_top - 0)).value;
                Expression result13 = new FilterParentPath(fexp, rlp);
                Symbol parser_result = new Symbol(19, ((Symbol)parser_stack.get(parser_top - 2)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result13);
                return parser_result;
            }
            case 66: {
                Expression fexp = (Expression)((Symbol)parser_stack.get(parser_top - 2)).value;
                Expression rlp = (Expression)((Symbol)parser_stack.get(parser_top - 0)).value;
                int nodeType = -1;
                if (rlp instanceof Step && this.parser.isElementAxis(((Step)rlp).getAxis())) {
                    nodeType = 1;
                }
                Step step = new Step(5, nodeType, null);
                FilterParentPath fpp = new FilterParentPath(fexp, step);
                fpp = new FilterParentPath(fpp, rlp);
                if (!(fexp instanceof KeyCall)) {
                    fpp.setDescendantAxis();
                }
                Symbol parser_result = new Symbol(19, ((Symbol)parser_stack.get(parser_top - 2)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, fpp);
                return parser_result;
            }
            case 67: {
                Expression rlp2 = (Expression)((Symbol)parser_stack.get(parser_top - 0)).value;
                Symbol parser_result = new Symbol(4, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, rlp2);
                return parser_result;
            }
            case 68: {
                Expression alp = (Expression)((Symbol)parser_stack.get(parser_top - 0)).value;
                Symbol parser_result = new Symbol(4, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, alp);
                return parser_result;
            }
            case 69: {
                Expression step2 = (Expression)((Symbol)parser_stack.get(parser_top - 0)).value;
                Symbol parser_result = new Symbol(21, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, step2);
                return parser_result;
            }
            case 70: {
                Expression result14 = null;
                Expression rlp = (Expression)((Symbol)parser_stack.get(parser_top - 2)).value;
                Expression step3 = (Expression)((Symbol)parser_stack.get(parser_top - 0)).value;
                if (rlp instanceof Step && ((Step)rlp).isAbbreviatedDot()) {
                    result14 = step3;
                }
                else if (((Step)step3).isAbbreviatedDot()) {
                    result14 = rlp;
                }
                else {
                    result14 = new ParentLocationPath((RelativeLocationPath)rlp, step3);
                }
                Symbol parser_result = new Symbol(21, ((Symbol)parser_stack.get(parser_top - 2)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result14);
                return parser_result;
            }
            case 71: {
                Expression arlp = (Expression)((Symbol)parser_stack.get(parser_top - 0)).value;
                Symbol parser_result = new Symbol(21, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, arlp);
                return parser_result;
            }
            case 72: {
                Expression result14 = new AbsoluteLocationPath();
                Symbol parser_result = new Symbol(23, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result14);
                return parser_result;
            }
            case 73: {
                Expression rlp2 = (Expression)((Symbol)parser_stack.get(parser_top - 0)).value;
                Expression result12 = new AbsoluteLocationPath(rlp2);
                Symbol parser_result = new Symbol(23, ((Symbol)parser_stack.get(parser_top - 1)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result12);
                return parser_result;
            }
            case 74: {
                Expression aalp = (Expression)((Symbol)parser_stack.get(parser_top - 0)).value;
                Symbol parser_result = new Symbol(23, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, aalp);
                return parser_result;
            }
            case 75: {
                Expression result14 = null;
                Expression rlp = (Expression)((Symbol)parser_stack.get(parser_top - 2)).value;
                Expression step3 = (Expression)((Symbol)parser_stack.get(parser_top - 0)).value;
                Step right = (Step)step3;
                int axis2 = right.getAxis();
                int type = right.getNodeType();
                List<Predicate> predicates = right.getPredicates();
                if (axis2 == 3 && type != 2) {
                    if (predicates == null) {
                        right.setAxis(4);
                        if (rlp instanceof Step && ((Step)rlp).isAbbreviatedDot()) {
                            result14 = right;
                        }
                        else {
                            RelativeLocationPath left = (RelativeLocationPath)rlp;
                            result14 = new ParentLocationPath(left, right);
                        }
                    }
                    else if (rlp instanceof Step && ((Step)rlp).isAbbreviatedDot()) {
                        Step left2 = new Step(5, 1, null);
                        result14 = new ParentLocationPath(left2, right);
                    }
                    else {
                        RelativeLocationPath left = (RelativeLocationPath)rlp;
                        Step mid = new Step(5, 1, null);
                        ParentLocationPath ppl = new ParentLocationPath(mid, right);
                        result14 = new ParentLocationPath(left, ppl);
                    }
                }
                else if (axis2 == 2 || type == 2) {
                    RelativeLocationPath left = (RelativeLocationPath)rlp;
                    Step middle = new Step(5, 1, null);
                    ParentLocationPath ppl = new ParentLocationPath(middle, right);
                    result14 = new ParentLocationPath(left, ppl);
                }
                else {
                    RelativeLocationPath left = (RelativeLocationPath)rlp;
                    Step middle = new Step(5, -1, null);
                    ParentLocationPath ppl = new ParentLocationPath(middle, right);
                    result14 = new ParentLocationPath(left, ppl);
                }
                Symbol parser_result = new Symbol(22, ((Symbol)parser_stack.get(parser_top - 2)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result14);
                return parser_result;
            }
            case 76: {
                Expression rlp2 = (Expression)((Symbol)parser_stack.get(parser_top - 0)).value;
                int nodeType2 = -1;
                if (rlp2 instanceof Step && this.parser.isElementAxis(((Step)rlp2).getAxis())) {
                    nodeType2 = 1;
                }
                Step step4 = new Step(5, nodeType2, null);
                Expression result15 = new AbsoluteLocationPath(this.parser.insertStep(step4, (RelativeLocationPath)rlp2));
                Symbol parser_result = new Symbol(24, ((Symbol)parser_stack.get(parser_top - 1)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result15);
                return parser_result;
            }
            case 77: {
                Expression result14 = null;
                Object ntest = ((Symbol)parser_stack.get(parser_top - 0)).value;
                if ((ntest instanceof Step)) {
                    result14 = (Step)ntest;
                }
                else {
                    result14 = new Step(3, this.parser.findNodeType(3, ntest), null);
                }
                Symbol parser_result = new Symbol(7, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result14);
                return parser_result;
            }
            case 78: {
                Expression result14 = null;
                Object ntest = ((Symbol)parser_stack.get(parser_top - 1)).value;
                List<Predicate> pp2 = (ArrayList)((Symbol)parser_stack.get(parser_top - 0)).value;
                if ((ntest instanceof Step)) {
                    Step step = (Step)ntest;
                    step.addPredicates(pp2);
                    result14 = (Step)ntest;
                }
                else {
                    result14 = new Step(3, this.parser.findNodeType(3, ntest), pp2);
                }
                Symbol parser_result = new Symbol(7, ((Symbol)parser_stack.get(parser_top - 1)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result14);
                return parser_result;
            }
            case 79: {
                Integer axis = (Integer)((Symbol)parser_stack.get(parser_top - 2)).value;
                Object ntest = ((Symbol)parser_stack.get(parser_top - 1)).value;
                List<Predicate> pp2 = (ArrayList)((Symbol)parser_stack.get(parser_top - 0)).value;
                Expression result15 = new Step((int)axis, this.parser.findNodeType((int)axis, ntest), pp2);
                Symbol parser_result = new Symbol(7, ((Symbol)parser_stack.get(parser_top - 2)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result15);
                return parser_result;
            }
            case 80: {
                Integer axis = (Integer)((Symbol)parser_stack.get(parser_top - 1)).value;
                Object ntest = ((Symbol)parser_stack.get(parser_top - 0)).value;
                Expression result13 = new Step((int)axis, this.parser.findNodeType((int)axis, ntest), null);
                Symbol parser_result = new Symbol(7, ((Symbol)parser_stack.get(parser_top - 1)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result13);
                return parser_result;
            }
            case 81: {
                Expression abbrev = (Expression)((Symbol)parser_stack.get(parser_top - 0)).value;
                Symbol parser_result = new Symbol(7, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, abbrev);
                return parser_result;
            }
            case 82: {
                Integer an = (Integer)((Symbol)parser_stack.get(parser_top - 1)).value;
                Symbol parser_result = new Symbol(41, ((Symbol)parser_stack.get(parser_top - 1)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, an);
                return parser_result;
            }
            case 83: {
                Integer result11 = Integer.valueOf(2);
                Symbol parser_result = new Symbol(41, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result11);
                return parser_result;
            }
            case 84: {
                Integer result11 = Integer.valueOf(0);
                Symbol parser_result = new Symbol(40, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result11);
                return parser_result;
            }
            case 85: {
                Integer result11 = Integer.valueOf(1);
                Symbol parser_result = new Symbol(40, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result11);
                return parser_result;
            }
            case 86: {
                Integer result11 = Integer.valueOf(2);
                Symbol parser_result = new Symbol(40, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result11);
                return parser_result;
            }
            case 87: {
                Integer result11 = Integer.valueOf(3);
                Symbol parser_result = new Symbol(40, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result11);
                return parser_result;
            }
            case 88: {
                Integer result11 = Integer.valueOf(4);
                Symbol parser_result = new Symbol(40, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result11);
                return parser_result;
            }
            case 89: {
                Integer result11 = Integer.valueOf(5);
                Symbol parser_result = new Symbol(40, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result11);
                return parser_result;
            }
            case 90: {
                Integer result11 = Integer.valueOf(6);
                Symbol parser_result = new Symbol(40, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result11);
                return parser_result;
            }
            case 91: {
                Integer result11 = Integer.valueOf(7);
                Symbol parser_result = new Symbol(40, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result11);
                return parser_result;
            }
            case 92: {
                Integer result11 = Integer.valueOf(9);
                Symbol parser_result = new Symbol(40, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result11);
                return parser_result;
            }
            case 93: {
                Integer result11 = Integer.valueOf(10);
                Symbol parser_result = new Symbol(40, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result11);
                return parser_result;
            }
            case 94: {
                Integer result11 = Integer.valueOf(11);
                Symbol parser_result = new Symbol(40, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result11);
                return parser_result;
            }
            case 95: {
                Integer result11 = Integer.valueOf(12);
                Symbol parser_result = new Symbol(40, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result11);
                return parser_result;
            }
            case 96: {
                Integer result11 = Integer.valueOf(13);
                Symbol parser_result = new Symbol(40, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result11);
                return parser_result;
            }
            case 97: {
                Expression result14 = new Step(13, -1, null);
                Symbol parser_result = new Symbol(20, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result14);
                return parser_result;
            }
            case 98: {
                Expression result14 = new Step(10, -1, null);
                Symbol parser_result = new Symbol(20, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result14);
                return parser_result;
            }
            case 99: {
                Expression primary = (Expression)((Symbol)parser_stack.get(parser_top - 0)).value;
                Symbol parser_result = new Symbol(6, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, primary);
                return parser_result;
            }
            case 100: {
                Expression primary = (Expression)((Symbol)parser_stack.get(parser_top - 1)).value;
                List<Expression> pp3 = (ArrayList)((Symbol)parser_stack.get(parser_top - 0)).value;
                Expression result13 = new FilterExpr(primary, pp3);
                Symbol parser_result = new Symbol(6, ((Symbol)parser_stack.get(parser_top - 1)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result13);
                return parser_result;
            }
            case 101: {
                Expression vr = (Expression)((Symbol)parser_stack.get(parser_top - 0)).value;
                Symbol parser_result = new Symbol(17, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, vr);
                return parser_result;
            }
            case 102: {
                Expression ex = (Expression)((Symbol)parser_stack.get(parser_top - 1)).value;
                Symbol parser_result = new Symbol(17, ((Symbol)parser_stack.get(parser_top - 2)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, ex);
                return parser_result;
            }
            case 103: {
                String string = (String)((Symbol)parser_stack.get(parser_top - 0)).value;
                String namespace = null;
                int index = string.lastIndexOf(58);
                if (index > 0) {
                    String prefix = string.substring(0, index);
                    namespace = this.parser._symbolTable.lookupNamespace(prefix);
                }
                Expression result15 = (namespace == null) ? new LiteralExpr(string) : new LiteralExpr(string, namespace);
                Symbol parser_result = new Symbol(17, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result15);
                return parser_result;
            }
            case 104: {
                Expression result14 = null;
                Long num = (Long)((Symbol)parser_stack.get(parser_top - 0)).value;
                if ((long)num < -2147483648L || (long)num > 2147483647L) {
                    result14 = new RealExpr((double)(long)num);
                }
                else if ((double)num == 0.0) {
                    result14 = new RealExpr((double)num);
                }
                else if (num.intValue() == 0) {
                    result14 = new IntExpr(num.intValue());
                }
                else if ((double)num == 0.0) {
                    result14 = new RealExpr((double)num);
                }
                else {
                    result14 = new IntExpr(num.intValue());
                }
                Symbol parser_result = new Symbol(17, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result14);
                return parser_result;
            }
            case 105: {
                Double num2 = (Double)((Symbol)parser_stack.get(parser_top - 0)).value;
                Expression result12 = new RealExpr((double)num2);
                Symbol parser_result = new Symbol(17, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result12);
                return parser_result;
            }
            case 106: {
                Expression fc = (Expression)((Symbol)parser_stack.get(parser_top - 0)).value;
                Symbol parser_result = new Symbol(17, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, fc);
                return parser_result;
            }
            case 107: {
                Expression result14 = null;
                QName varName = (QName)((Symbol)parser_stack.get(parser_top - 0)).value;
                SyntaxTreeNode node = this.parser.lookupName(varName);
                if (node != null) {
                    if ((node instanceof Variable)) {
                        result14 = new VariableRef((Variable)node);
                    }
                    else if ((node instanceof Param)) {
                        result14 = new ParameterRef((Param)node);
                    }
                    else {
                        result14 = new UnresolvedRef(varName);
                    }
                }
                if (node == null) {
                    result14 = new UnresolvedRef(varName);
                }
                Symbol parser_result = new Symbol(15, ((Symbol)parser_stack.get(parser_top - 1)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result14);
                return parser_result;
            }
            case 108: {
                Expression result14 = null;
                QName fname = (QName)((Symbol)parser_stack.get(parser_top - 2)).value;
                if (fname == this.parser.getQNameIgnoreDefaultNs("current")) {
                    result14 = new CurrentCall(fname);
                }
                else if (fname == this.parser.getQNameIgnoreDefaultNs("number")) {
                    result14 = new NumberCall(fname, XPathParser.EmptyArgs);
                }
                else if (fname == this.parser.getQNameIgnoreDefaultNs("string")) {
                    result14 = new StringCall(fname, XPathParser.EmptyArgs);
                }
                else if (fname == this.parser.getQNameIgnoreDefaultNs("concat")) {
                    result14 = new ConcatCall(fname, XPathParser.EmptyArgs);
                }
                else if (fname == this.parser.getQNameIgnoreDefaultNs("true")) {
                    result14 = new BooleanExpr(true);
                }
                else if (fname == this.parser.getQNameIgnoreDefaultNs("false")) {
                    result14 = new BooleanExpr(false);
                }
                else if (fname == this.parser.getQNameIgnoreDefaultNs("name")) {
                    result14 = new NameCall(fname);
                }
                else if (fname == this.parser.getQNameIgnoreDefaultNs("generate-id")) {
                    result14 = new GenerateIdCall(fname, XPathParser.EmptyArgs);
                }
                else if (fname == this.parser.getQNameIgnoreDefaultNs("string-length")) {
                    result14 = new StringLengthCall(fname, XPathParser.EmptyArgs);
                }
                else if (fname == this.parser.getQNameIgnoreDefaultNs("position")) {
                    result14 = new PositionCall(fname);
                }
                else if (fname == this.parser.getQNameIgnoreDefaultNs("last")) {
                    result14 = new LastCall(fname);
                }
                else if (fname == this.parser.getQNameIgnoreDefaultNs("local-name")) {
                    result14 = new LocalNameCall(fname);
                }
                else if (fname == this.parser.getQNameIgnoreDefaultNs("namespace-uri")) {
                    result14 = new NamespaceUriCall(fname);
                }
                else {
                    result14 = new FunctionCall(fname, XPathParser.EmptyArgs);
                }
                Symbol parser_result = new Symbol(16, ((Symbol)parser_stack.get(parser_top - 2)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result14);
                return parser_result;
            }
            case 109: {
                Expression result14 = null;
                QName fname = (QName)((Symbol)parser_stack.get(parser_top - 3)).value;
                List<Expression> argl = (ArrayList)((Symbol)parser_stack.get(parser_top - 1)).value;
                if (fname == this.parser.getQNameIgnoreDefaultNs("concat")) {
                    result14 = new ConcatCall(fname, argl);
                }
                else if (fname == this.parser.getQNameIgnoreDefaultNs("number")) {
                    result14 = new NumberCall(fname, argl);
                }
                else if (fname == this.parser.getQNameIgnoreDefaultNs("document")) {
                    this.parser.setMultiDocument(true);
                    result14 = new DocumentCall(fname, argl);
                }
                else if (fname == this.parser.getQNameIgnoreDefaultNs("string")) {
                    result14 = new StringCall(fname, argl);
                }
                else if (fname == this.parser.getQNameIgnoreDefaultNs("boolean")) {
                    result14 = new BooleanCall(fname, argl);
                }
                else if (fname == this.parser.getQNameIgnoreDefaultNs("name")) {
                    result14 = new NameCall(fname, argl);
                }
                else if (fname == this.parser.getQNameIgnoreDefaultNs("generate-id")) {
                    result14 = new GenerateIdCall(fname, argl);
                }
                else if (fname == this.parser.getQNameIgnoreDefaultNs("not")) {
                    result14 = new NotCall(fname, argl);
                }
                else if (fname == this.parser.getQNameIgnoreDefaultNs("format-number")) {
                    result14 = new FormatNumberCall(fname, argl);
                }
                else if (fname == this.parser.getQNameIgnoreDefaultNs("unparsed-entity-uri")) {
                    result14 = new UnparsedEntityUriCall(fname, argl);
                }
                else if (fname == this.parser.getQNameIgnoreDefaultNs("key")) {
                    result14 = new KeyCall(fname, argl);
                }
                else if (fname == this.parser.getQNameIgnoreDefaultNs("id")) {
                    result14 = new KeyCall(fname, argl);
                    this.parser.setHasIdCall(true);
                }
                else if (fname == this.parser.getQNameIgnoreDefaultNs("ceiling")) {
                    result14 = new CeilingCall(fname, argl);
                }
                else if (fname == this.parser.getQNameIgnoreDefaultNs("round")) {
                    result14 = new RoundCall(fname, argl);
                }
                else if (fname == this.parser.getQNameIgnoreDefaultNs("floor")) {
                    result14 = new FloorCall(fname, argl);
                }
                else if (fname == this.parser.getQNameIgnoreDefaultNs("contains")) {
                    result14 = new ContainsCall(fname, argl);
                }
                else if (fname == this.parser.getQNameIgnoreDefaultNs("string-length")) {
                    result14 = new StringLengthCall(fname, argl);
                }
                else if (fname == this.parser.getQNameIgnoreDefaultNs("starts-with")) {
                    result14 = new StartsWithCall(fname, argl);
                }
                else if (fname == this.parser.getQNameIgnoreDefaultNs("function-available")) {
                    result14 = new FunctionAvailableCall(fname, argl);
                }
                else if (fname == this.parser.getQNameIgnoreDefaultNs("element-available")) {
                    result14 = new ElementAvailableCall(fname, argl);
                }
                else if (fname == this.parser.getQNameIgnoreDefaultNs("local-name")) {
                    result14 = new LocalNameCall(fname, argl);
                }
                else if (fname == this.parser.getQNameIgnoreDefaultNs("lang")) {
                    result14 = new LangCall(fname, argl);
                }
                else if (fname == this.parser.getQNameIgnoreDefaultNs("namespace-uri")) {
                    result14 = new NamespaceUriCall(fname, argl);
                }
                else if (fname == this.parser.getQName("http://xml.apache.org/xalan/xsltc", "xsltc", "cast")) {
                    result14 = new CastCall(fname, argl);
                }
                else if (fname.getLocalPart().equals("nodeset") || fname.getLocalPart().equals("node-set")) {
                    this.parser.setCallsNodeset(true);
                    result14 = new FunctionCall(fname, argl);
                }
                else {
                    result14 = new FunctionCall(fname, argl);
                }
                Symbol parser_result = new Symbol(16, ((Symbol)parser_stack.get(parser_top - 3)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result14);
                return parser_result;
            }
            case 110: {
                Expression arg = (Expression)((Symbol)parser_stack.get(parser_top - 0)).value;
                List<Expression> temp = new ArrayList();
                temp.add(arg);
                Symbol parser_result = new Symbol(36, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, temp);
                return parser_result;
            }
            case 111: {
                Expression arg = (Expression)((Symbol)parser_stack.get(parser_top - 2)).value;
                List<Expression> argl2 = (ArrayList)((Symbol)parser_stack.get(parser_top - 0)).value;
                argl2.add(0, arg);
                Symbol parser_result = new Symbol(36, ((Symbol)parser_stack.get(parser_top - 2)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, argl2);
                return parser_result;
            }
            case 112: {
                QName fname2 = (QName)((Symbol)parser_stack.get(parser_top - 0)).value;
                Symbol parser_result = new Symbol(38, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, fname2);
                return parser_result;
            }
            case 113: {
                QName vname = (QName)((Symbol)parser_stack.get(parser_top - 0)).value;
                Symbol parser_result = new Symbol(39, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, vname);
                return parser_result;
            }
            case 114: {
                Expression ex = (Expression)((Symbol)parser_stack.get(parser_top - 0)).value;
                Symbol parser_result = new Symbol(3, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, ex);
                return parser_result;
            }
            case 115: {
                Object nt = ((Symbol)parser_stack.get(parser_top - 0)).value;
                Symbol parser_result = new Symbol(25, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, nt);
                return parser_result;
            }
            case 116: {
                Object result10 = Integer.valueOf(-1);
                Symbol parser_result = new Symbol(25, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result10);
                return parser_result;
            }
            case 117: {
                Object result10 = Integer.valueOf(3);
                Symbol parser_result = new Symbol(25, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result10);
                return parser_result;
            }
            case 118: {
                Object result10 = Integer.valueOf(8);
                Symbol parser_result = new Symbol(25, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result10);
                return parser_result;
            }
            case 119: {
                String l = (String)((Symbol)parser_stack.get(parser_top - 1)).value;
                QName name = this.parser.getQNameIgnoreDefaultNs("name");
                Expression exp = new EqualityExpr(0, new NameCall(name), new LiteralExpr(l));
                List<Predicate> predicates2 = new ArrayList();
                predicates2.add(new Predicate(exp));
                Step result16 = new Step(3, 7, predicates2);
                Symbol parser_result = new Symbol(25, ((Symbol)parser_stack.get(parser_top - 3)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result16);
                return parser_result;
            }
            case 120: {
                Object result10 = Integer.valueOf(7);
                Symbol parser_result = new Symbol(25, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result10);
                return parser_result;
            }
            case 121: {
                Object result10 = null;
                Symbol parser_result = new Symbol(26, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result10);
                return parser_result;
            }
            case 122: {
                QName qn = (QName)((Symbol)parser_stack.get(parser_top - 0)).value;
                Symbol parser_result = new Symbol(26, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, qn);
                return parser_result;
            }
            case 123: {
                String qname = (String)((Symbol)parser_stack.get(parser_top - 0)).value;
                QName result17 = this.parser.getQNameIgnoreDefaultNs(qname);
                Symbol parser_result = new Symbol(37, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result17);
                return parser_result;
            }
            case 124: {
                QName result18 = this.parser.getQNameIgnoreDefaultNs("div");
                Symbol parser_result = new Symbol(37, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result18);
                return parser_result;
            }
            case 125: {
                QName result18 = this.parser.getQNameIgnoreDefaultNs("mod");
                Symbol parser_result = new Symbol(37, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result18);
                return parser_result;
            }
            case 126: {
                QName result18 = this.parser.getQNameIgnoreDefaultNs("key");
                Symbol parser_result = new Symbol(37, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result18);
                return parser_result;
            }
            case 127: {
                QName result18 = this.parser.getQNameIgnoreDefaultNs("child");
                Symbol parser_result = new Symbol(37, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result18);
                return parser_result;
            }
            case 128: {
                QName result18 = this.parser.getQNameIgnoreDefaultNs("ancestor-or-self");
                Symbol parser_result = new Symbol(37, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result18);
                return parser_result;
            }
            case 129: {
                QName result18 = this.parser.getQNameIgnoreDefaultNs("attribute");
                Symbol parser_result = new Symbol(37, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result18);
                return parser_result;
            }
            case 130: {
                QName result18 = this.parser.getQNameIgnoreDefaultNs("child");
                Symbol parser_result = new Symbol(37, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result18);
                return parser_result;
            }
            case 131: {
                QName result18 = this.parser.getQNameIgnoreDefaultNs("decendant");
                Symbol parser_result = new Symbol(37, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result18);
                return parser_result;
            }
            case 132: {
                QName result18 = this.parser.getQNameIgnoreDefaultNs("decendant-or-self");
                Symbol parser_result = new Symbol(37, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result18);
                return parser_result;
            }
            case 133: {
                QName result18 = this.parser.getQNameIgnoreDefaultNs("following");
                Symbol parser_result = new Symbol(37, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result18);
                return parser_result;
            }
            case 134: {
                QName result18 = this.parser.getQNameIgnoreDefaultNs("following-sibling");
                Symbol parser_result = new Symbol(37, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result18);
                return parser_result;
            }
            case 135: {
                QName result18 = this.parser.getQNameIgnoreDefaultNs("namespace");
                Symbol parser_result = new Symbol(37, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result18);
                return parser_result;
            }
            case 136: {
                QName result18 = this.parser.getQNameIgnoreDefaultNs("parent");
                Symbol parser_result = new Symbol(37, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result18);
                return parser_result;
            }
            case 137: {
                QName result18 = this.parser.getQNameIgnoreDefaultNs("preceding");
                Symbol parser_result = new Symbol(37, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result18);
                return parser_result;
            }
            case 138: {
                QName result18 = this.parser.getQNameIgnoreDefaultNs("preceding-sibling");
                Symbol parser_result = new Symbol(37, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result18);
                return parser_result;
            }
            case 139: {
                QName result18 = this.parser.getQNameIgnoreDefaultNs("self");
                Symbol parser_result = new Symbol(37, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result18);
                return parser_result;
            }
            case 140: {
                QName result18 = this.parser.getQNameIgnoreDefaultNs("id");
                Symbol parser_result = new Symbol(37, ((Symbol)parser_stack.get(parser_top - 0)).left, ((Symbol)parser_stack.get(parser_top - 0)).right, result18);
                return parser_result;
            }
            default: {
                throw new Exception("Invalid action number found in internal parse table");
            }
        }
    }
}
